]> git.saurik.com Git - apt.git/blob - test/integration/framework
eipp: implement version 0.1 of the protocol
[apt.git] / test / integration / framework
1 #!/bin/sh -- # no runable script, just for vi
2
3 EXIT_CODE=0
4
5 while [ -n "$1" ]; do
6 if [ "$1" = "-q" ]; then
7 export MSGLEVEL=2
8 elif [ "$1" = "-v" ]; then
9 export MSGLEVEL=4
10 elif [ "$1" = '--color=no' ]; then
11 export MSGCOLOR='NO'
12 elif [ "$1" = '--color=yes' ]; then
13 export MSGCOLOR='YES'
14 elif [ "$1" = '--color' ]; then
15 export MSGCOLOR="$(echo "$2" | tr 'a-z' 'A-Z')"
16 shift
17 elif [ "$1" = '--level' ]; then
18 export MSGLEVEL=$2
19 shift
20 else
21 echo >&2 "WARNING: Unknown parameter »$1« will be ignored"
22 fi
23 shift
24 done
25 export MSGLEVEL="${MSGLEVEL:-3}"
26
27 # we all like colorful messages
28 if [ "${MSGCOLOR:-YES}" = 'YES' ]; then
29 if [ ! -t 1 ]; then # but check that we output to a terminal
30 export MSGCOLOR='NO'
31 fi
32 fi
33
34
35 if [ "$MSGCOLOR" != 'NO' ]; then
36 CERROR="\033[1;31m" # red
37 CWARNING="\033[1;33m" # yellow
38 CMSG="\033[1;32m" # green
39 CINFO="\033[1;96m" # light blue
40 CDEBUG="\033[1;94m" # blue
41 CNORMAL="\033[0;39m" # default system console color
42 CDONE="\033[1;32m" # green
43 CPASS="\033[1;32m" # green
44 CFAIL="\033[1;31m" # red
45 CCMD="\033[1;35m" # pink
46 fi
47
48 msgprintf() {
49 local START="$1"
50 local MIDDLE="$2"
51 local END="$3"
52 shift 3
53 if [ -n "$1" ]; then
54 printf "$START " "$1"
55 shift
56 while [ -n "$1" ]; do
57 printf "$MIDDLE " "$(echo "$1" | sed -e 's#^apt\([cfghks]\)#apt-\1#')"
58 shift
59 done
60 fi
61 printf "${END}"
62 }
63 msgdie() { msgprintf "${CERROR}E: %s" '%s' "${CNORMAL}\n" "$@" >&2; exit 1; }
64 msgwarn() { msgprintf "${CWARNING}W: %s" '%s' "${CNORMAL}\n" "$@" >&2; }
65 msgmsg() { msgprintf "${CMSG}%s" '%s' "${CNORMAL}\n" "$@"; }
66 msginfo() { msgprintf "${CINFO}I: %s" '%s' "${CNORMAL}\n" "$@"; }
67 msgdebug() { msgprintf "${CDEBUG}D: %s" '%s' "${CNORMAL}\n" "$@"; }
68 msgdone() { msgprintf "${CDONE}DONE" '%s' "${CNORMAL}\n" "$@"; }
69 msgnwarn() { msgprintf "${CWARNING}W: %s" '%s' "${CNORMAL}" "$@" >&2; }
70 msgnmsg() { msgprintf "${CMSG}%s" '%s' "${CNORMAL}" "$@"; }
71 msgninfo() { msgprintf "${CINFO}I: %s" '%s' "${CNORMAL}" "$@"; }
72 msgndebug() { msgprintf "${CDEBUG}D: %s" '%s' "${CNORMAL}" "$@"; }
73 msgtest() { msgprintf "${CINFO}%s" "${CCMD}%s${CINFO}" "…${CNORMAL} " "$@"; }
74 msgpass() { printf "${CPASS}PASS${CNORMAL}\n"; }
75 msgreportheader() {
76 if [ -n "$MSGTEST_MSG" ]; then
77 test "$1" != 'msgfailoutput' || echo
78 if [ -n "$MSGTEST_MSGMSG" ]; then
79 echo "$MSGTEST_MSGMSG"
80 fi
81 if [ -n "$MSGTEST_GRP" ] && [ "$MSGTEST_GRP" != 'NEXT' ] && [ "$MSGTEST_GRP" != "$MSGTEST_MSG" ]; then
82 echo "${CFAIL}Part of the test group: $MSGTEST_GRP"
83 fi
84 echo -n "$MSGTEST_MSG"
85 unset MSGTEST_MSG
86 fi
87 }
88 msgskip() {
89 msgreportheader 'msgskip'
90 if [ $# -gt 0 ]; then printf "${CWARNING}SKIP: $*${CNORMAL}\n" >&2;
91 else printf "${CWARNING}SKIP${CNORMAL}\n" >&2; fi
92 }
93 msgfail() {
94 msgreportheader 'msgfail'
95 if [ $# -gt 0 ] && [ -n "$1" ]; then printf "${CFAIL}FAIL: $*${CNORMAL}\n" >&2;
96 else printf "${CFAIL}FAIL${CNORMAL}\n" >&2; fi
97 if [ -n "$APT_DEBUG_TESTS" ]; then
98 runapt $SHELL
99 fi
100 EXIT_CODE=$((EXIT_CODE+1));
101 }
102 MSGGROUP_LEVEL=0
103 msggroup() {
104 if [ -n "$1" ]; then
105 if [ $MSGGROUP_LEVEL = 0 ]; then
106 MSGTEST_GRP='NEXT'
107 fi
108 MSGGROUP_LEVEL=$((MSGGROUP_LEVEL+1));
109 else
110 MSGGROUP_LEVEL=$((MSGGROUP_LEVEL-1));
111 if [ $MSGGROUP_LEVEL = 0 ]; then
112 unset MSGTEST_GRP
113 fi
114 fi
115 }
116
117 # enable / disable Debugging
118 if [ $MSGLEVEL -le 0 ]; then
119 msgdie() { true; }
120 fi
121 if [ $MSGLEVEL -le 1 ]; then
122 msgwarn() { true; }
123 msgnwarn() { true; }
124 fi
125 if [ $MSGLEVEL -le 2 ]; then
126 msgmsg() {
127 MSGTEST_MSGMSG="$(msgprintf "${CMSG}%s" '%s' "${CNORMAL}" "$@")"
128 }
129 msgnmsg() { true; }
130 msgtest() {
131 MSGTEST_MSG="$(msgprintf "${CINFO}%s" "${CCMD}%s${CINFO}" "…${CNORMAL} " "$@")"
132 if [ "$MSGTEST_GRP" = 'NEXT' ]; then
133 MSGTEST_GRP="$MSGTEST_MSG"
134 fi
135 }
136 msgpass() { printf " ${CPASS}P${CNORMAL}"; }
137 fi
138 if [ $MSGLEVEL -le 3 ]; then
139 msginfo() { true; }
140 msgninfo() { true; }
141 fi
142 if [ $MSGLEVEL -le 4 ]; then
143 msgdebug() { true; }
144 msgndebug() { true; }
145 fi
146 msgdone() {
147 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
148 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
149 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
150 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
151 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
152 true;
153 else
154 printf "${CDONE}DONE${CNORMAL}\n";
155 fi
156 }
157 getaptconfig() {
158 if [ -f ./aptconfig.conf ]; then
159 echo "$(readlink -f ./aptconfig.conf)"
160 elif [ -f ../aptconfig.conf ]; then
161 echo "$(readlink -f ../aptconfig.conf)"
162 elif [ -f ../../aptconfig.conf ]; then
163 echo "$(readlink -f ../../aptconfig.conf)"
164 elif [ -f "${TMPWORKINGDIRECTORY}/aptconfig.conf" ]; then
165 echo "$(readlink -f "${TMPWORKINGDIRECTORY}/aptconfig.conf")"
166 fi
167 }
168 runapt() {
169 msgdebug "Executing: ${CCMD}$*${CDEBUG} "
170 local CMD="$1"
171 shift
172 case "$CMD" in
173 sh|aptitude|*/*|command) ;;
174 *) CMD="${BUILDDIRECTORY}/$CMD";;
175 esac
176 MALLOC_PERTURB_=21 MALLOC_CHECK_=2 APT_CONFIG="$(getaptconfig)" LD_LIBRARY_PATH="${LIBRARYPATH}:${LD_LIBRARY_PATH}" "$CMD" "$@"
177 }
178 runpython3() { runapt command python3 "$@"; }
179 aptconfig() { runapt apt-config "$@"; }
180 aptcache() { runapt apt-cache "$@"; }
181 aptcdrom() { runapt apt-cdrom "$@"; }
182 aptget() { runapt apt-get "$@"; }
183 aptftparchive() { runapt apt-ftparchive "$@"; }
184 aptkey() { runapt apt-key "$@"; }
185 aptmark() { runapt apt-mark "$@"; }
186 aptsortpkgs() { runapt apt-sortpkgs "$@"; }
187 apt() { runapt apt "$@"; }
188 apthelper() { runapt "${APTHELPERBINDIR}/apt-helper" "$@"; }
189 aptwebserver() { runapt "${APTWEBSERVERBINDIR}/aptwebserver" "$@"; }
190 aptitude() { runapt aptitude "$@"; }
191 aptextracttemplates() { runapt apt-extracttemplates "$@"; }
192 aptinternalsolver() { runapt "${APTINTERNALSOLVER}" "$@"; }
193 aptdumpsolver() { runapt "${APTDUMPSOLVER}" "$@"; }
194
195 dpkg() {
196 "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" "$@"
197 }
198 dpkgcheckbuilddeps() {
199 command dpkg-checkbuilddeps --admindir="${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg" "$@"
200 }
201 gdb() {
202 local CMD
203 case "$1" in
204 aptget) CMD="apt-get";;
205 aptcache) CMD="apt-cache";;
206 aptcdrom) CMD="apt-cdrom";;
207 aptconfig) CMD="apt-config";;
208 aptmark) CMD="apt-mark";;
209 apthelper) CMD="apt-helper";;
210 aptftparchive) CMD="apt-ftparchive";;
211 dpkg) shift; runapt "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg" "$@"; return;;
212 *) CMD="$1";;
213 esac
214 shift
215 if [ "${CMD##*/}" = "$CMD" ]; then
216 CMD="${BUILDDIRECTORY}/${CMD}"
217 fi
218 runapt command gdb --quiet -ex run "$CMD" --args "$CMD" "$@"
219 }
220 lastmodification() {
221 date -u -d "@$(stat -c '%Y' "${TMPWORKINGDIRECTORY}/$1")" '+%a, %d %b %Y %H:%M:%S GMT'
222 }
223 releasefiledate() {
224 grep "^${2:-Date}:" "$1" | cut -d' ' -f 2- | sed -e 's#UTC#GMT#'
225 }
226
227 exitwithstatus() {
228 # error if we about to overflow, but ...
229 # "255 failures ought to be enough for everybody"
230 if [ $EXIT_CODE -gt 255 ]; then
231 msgdie "Total failure count $EXIT_CODE too big"
232 fi
233 exit $((EXIT_CODE <= 255 ? EXIT_CODE : 255));
234 }
235
236 shellsetedetector() {
237 local exit_status=$?
238 if [ "$exit_status" != '0' ]; then
239 printf >&2 "${CERROR}E: Looks like the testcases ended prematurely with exitcode: ${exit_status}${CNORMAL}\n"
240 if [ "$EXIT_CODE" = '0' ]; then
241 EXIT_CODE="$exit_status"
242 fi
243 fi
244 }
245
246 addtrap() {
247 if [ "$1" = 'prefix' ]; then
248 CURRENTTRAP="$2 $CURRENTTRAP"
249 else
250 CURRENTTRAP="$CURRENTTRAP $1"
251 fi
252 trap "shellsetedetector; $CURRENTTRAP exitwithstatus;" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
253 }
254
255 escape_shell() {
256 echo "$@" | sed -e "s#'#'\"'\"'#g"
257 }
258
259 setupenvironment() {
260 # privilege dropping and testing doesn't work if /tmp isn't world-writeable (as e.g. with libpam-tmpdir)
261 if [ -n "$TMPDIR" ] && [ "$(id -u)" = '0' ] && [ "$(stat --format '%a' "$TMPDIR")" != '1777' ]; then
262 unset TMPDIR
263 fi
264 TMPWORKINGDIRECTORY="$(mktemp -d)"
265 addtrap "cd /; rm -rf '$(escape_shell "$TMPWORKINGDIRECTORY")';"
266 if [ -n "$TMPDIR_ADD" ]; then
267 TMPWORKINGDIRECTORY="${TMPWORKINGDIRECTORY}/${TMPDIR_ADD}"
268 mkdir -p "$TMPWORKINGDIRECTORY"
269 unset TMPDIR_ADD
270 export TMPDIR="$TMPWORKINGDIRECTORY"
271 fi
272 msgninfo "Preparing environment for ${0##*/} in ${TMPWORKINGDIRECTORY}…"
273
274 mkdir -m 700 "${TMPWORKINGDIRECTORY}/downloaded"
275 if [ "$(id -u)" = '0' ]; then
276 # relax permissions so that running as root with user switching works
277 umask 022
278 chmod 711 "$TMPWORKINGDIRECTORY"
279 chown _apt:root "${TMPWORKINGDIRECTORY}/downloaded"
280 fi
281
282 TESTDIRECTORY="$(readlink -f "$(dirname $0)")"
283 # allow overriding the default BUILDDIR location
284 SOURCEDIRECTORY="${APT_INTEGRATION_TESTS_SOURCE_DIR:-"${TESTDIRECTORY}/../../"}"
285 BUILDDIRECTORY="${APT_INTEGRATION_TESTS_BUILD_DIR:-"${TESTDIRECTORY}/../../build/bin"}"
286 LIBRARYPATH="${APT_INTEGRATION_TESTS_LIBRARY_PATH:-"${BUILDDIRECTORY}"}"
287 METHODSDIR="${APT_INTEGRATION_TESTS_METHODS_DIR:-"${BUILDDIRECTORY}/methods"}"
288 APTHELPERBINDIR="${APT_INTEGRATION_TESTS_LIBEXEC_DIR:-"${BUILDDIRECTORY}"}"
289 APTWEBSERVERBINDIR="${APT_INTEGRATION_TESTS_WEBSERVER_BIN_DIR:-"${BUILDDIRECTORY}"}"
290 APTINTERNALSOLVER="${APT_INTEGRATION_TESTS_INTERNAL_SOLVER:-"${BUILDDIRECTORY}/apt-internal-solver"}"
291 APTDUMPSOLVER="${APT_INTEGRATION_TESTS_DUMP_SOLVER:-"${BUILDDIRECTORY}/apt-dump-solver"}"
292 test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
293 # -----
294
295 cd "$TMPWORKINGDIRECTORY"
296 mkdir rootdir aptarchive keys
297 cd rootdir
298 mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
299 mkdir -p usr/bin var/cache var/lib var/log tmp
300 mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
301 touch var/lib/dpkg/available
302 mkdir -p usr/lib/apt
303 ln -s "${METHODSDIR}" usr/lib/apt/methods
304 if [ "$BUILDDIRECTORY" = "$LIBRARYPATH" ]; then
305 mkdir -p usr/lib/apt/solvers usr/lib/apt/planers
306 ln -s "${BUILDDIRECTORY}/apt-dump-solver" usr/lib/apt/solvers/dump
307 ln -s "${BUILDDIRECTORY}/apt-dump-solver" usr/lib/apt/planers/dump
308 ln -s "${BUILDDIRECTORY}/apt-internal-solver" usr/lib/apt/solvers/apt
309 echo "Dir::Bin::Solvers \"${TMPWORKINGDIRECTORY}/rootdir/usr/lib/apt/solvers\";" > etc/apt/apt.conf.d/externalsolver.conf
310 echo "Dir::Bin::Planers \"${TMPWORKINGDIRECTORY}/rootdir/usr/lib/apt/planers\";" > etc/apt/apt.conf.d/externalplaner.conf
311 fi
312 # use the autoremove from the BUILDDIRECTORY if its there, otherwise
313 # system
314 if [ -e "${BUILDDIRECTORY}/../../debian/apt.conf.autoremove" ]; then
315 ln -s "${BUILDDIRECTORY}/../../debian/apt.conf.autoremove" etc/apt/apt.conf.d/01autoremove
316 else
317 ln -s /etc/apt/apt.conf.d/01autoremove etc/apt/apt.conf.d/01autoremove
318 fi
319 cd ..
320 local BASENAME="${0##*/}"
321 local PACKAGESFILE="Packages-${BASENAME#*-}"
322 if [ -f "${TESTDIRECTORY}/${PACKAGESFILE}" ]; then
323 cp "${TESTDIRECTORY}/${PACKAGESFILE}" aptarchive/Packages
324 fi
325 local SOURCESSFILE="Sources-${BASENAME#*-}"
326 if [ -f "${TESTDIRECTORY}/${SOURCESSFILE}" ]; then
327 cp "${TESTDIRECTORY}/${SOURCESSFILE}" aptarchive/Sources
328 fi
329 find "$TESTDIRECTORY" \( -name '*.pub' -o -name '*.sec' \) -exec cp '{}' keys/ \;
330 chmod 644 keys/*
331 ln -s "${TMPWORKINGDIRECTORY}/keys/joesixpack.pub" rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
332
333 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
334 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
335 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
336 echo "Dir::Bin::Methods \"${TMPWORKINGDIRECTORY}/rootdir/usr/lib/apt/methods\";" >> aptconfig.conf
337 # either store apt-key were we can access it, even if we run it as a different user
338 #cp "${BUILDDIRECTORY}/apt-key" "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/"
339 #chmod o+rx "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/apt-key"
340 #echo "Dir::Bin::apt-key \"${TMPWORKINGDIRECTORY}/rootdir/usr/bin/apt-key\";" >> aptconfig.conf
341 # destroys coverage reporting though, so we disable changing user for the calling gpgv
342 echo "Dir::Bin::apt-key \"${BUILDDIRECTORY}/apt-key\";" >> aptconfig.conf
343 if [ "$(id -u)" = '0' ]; then
344 echo 'Binary::gpgv::APT::Sandbox::User "root";' >> aptconfig.conf
345 # same for the solver executables
346 echo 'APT::Solver::RunAsUser "root";' >> aptconfig.conf
347 fi
348
349 cat > "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" <<EOF
350 #!/bin/sh
351 set -e
352 if [ -r '${TMPWORKINGDIRECTORY}/noopchroot.so' ]; then
353 if [ -n "\$LD_LIBRARY_PATH" ]; then
354 export LD_LIBRARY_PATH='${TMPWORKINGDIRECTORY}:'"\${LD_LIBRARY_PATH}"
355 else
356 export LD_LIBRARY_PATH='${TMPWORKINGDIRECTORY}'
357 fi
358 if [ -n "\$LD_PRELOAD" ]; then
359 export LD_PRELOAD="noopchroot.so \${LD_PRELOAD}"
360 else
361 export LD_PRELOAD="noopchroot.so"
362 fi
363 fi
364 EOF
365 cp "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg"
366 cat >> "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" <<EOF
367 exec fakeroot '${DPKG:-dpkg}' --root='${TMPWORKINGDIRECTORY}/rootdir' \\
368 --log='${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log' \\
369 --force-not-root --force-bad-path "\$@"
370 EOF
371 cat >> "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg" <<EOF
372 exec fakeroot gdb --quiet -ex run '${DPKG:-dpkg}' --args '${DPKG:-dpkg}' --root='${TMPWORKINGDIRECTORY}/rootdir' \\
373 --log='${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log' \\
374 --force-not-root --force-bad-path "\$@"
375 EOF
376 chmod +x "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg"
377 echo "Dir::Bin::dpkg \"${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg\";" > rootdir/etc/apt/apt.conf.d/99dpkg
378
379 {
380 if ! command dpkg --assert-multi-arch >/dev/null 2>&1; then
381 echo "DPKG::options:: \"--force-architecture\";" # Added to test multiarch before dpkg is ready for it…
382 fi
383 echo 'quiet "0";'
384 echo 'quiet::NoUpdate "true";'
385 echo 'quiet::NoStatistic "true";'
386 # too distracting for users, but helpful to detect changes
387 echo 'Acquire::Progress::Ignore::ShowErrorText "true";'
388 echo 'Acquire::Progress::Diffpercent "true";'
389 # in testcases, it can appear as if localhost has a rotation setup,
390 # hide this as we can't really deal with it properly
391 echo 'Acquire::Failure::ShowIP "false";'
392 # fakeroot can't fake everything, so disabled in production but good for tests
393 echo 'APT::Sandbox::Verify "true";'
394 } >> aptconfig.conf
395
396 cp "${TESTDIRECTORY}/apt.pem" "${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem"
397 if [ "$(id -u)" = '0' ]; then
398 chown _apt:root "${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem"
399 fi
400 echo "Acquire::https::CaInfo \"${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem\";" > rootdir/etc/apt/apt.conf.d/99https
401 echo "Apt::Cmd::Disable-Script-Warning \"1\";" > rootdir/etc/apt/apt.conf.d/apt-binary
402 echo 'Acquire::Connect::AddrConfig "false";' > rootdir/etc/apt/apt.conf.d/connect-addrconfig
403
404 configcompression '.' 'gz' #'bz2' 'lzma' 'xz'
405 confighashes 'SHA256' # these are tests, not security best-practices
406
407 # create some files in /tmp and look at user/group to get what this means
408 TEST_DEFAULT_USER="$(id -un)"
409 if [ "$(uname)" = 'GNU/kFreeBSD' ]; then
410 TEST_DEFAULT_GROUP='root'
411 else
412 TEST_DEFAULT_GROUP="$(id -gn)"
413 fi
414
415 # cleanup the environment a bit
416 # prefer our apt binaries over the system apt binaries
417 export PATH="${BUILDDIRECTORY}:${PATH}:/usr/local/sbin:/usr/sbin:/sbin"
418 export LC_ALL=C.UTF-8
419 unset LANGUAGE APT_CONFIG
420 unset GREP_OPTIONS DEB_BUILD_PROFILES
421 unset http_proxy HTTP_PROXY https_proxy HTTPS_PROXY no_proxy
422
423 # If gpgv supports --weak-digest, pass it to make sure we can disable SHA1
424 if aptkey verify --weak-digest SHA1 --help 2>/dev/null >/dev/null; then
425 echo 'Acquire::gpgv::Options { "--weak-digest"; "sha1"; };' > rootdir/etc/apt/apt.conf.d/no-sha1
426 fi
427
428 # most tests just need one signed Release file, not both
429 export APT_DONT_SIGN='Release.gpg'
430
431 msgdone "info"
432 }
433
434 getarchitecture() {
435 if [ "$1" = "native" -o -z "$1" ]; then
436 eval `aptconfig shell ARCH APT::Architecture`
437 if [ -n "$ARCH" ]; then
438 echo $ARCH
439 else
440 dpkg --print-architecture
441 fi
442 else
443 echo $1
444 fi
445 }
446
447 getarchitectures() {
448 aptconfig dump --no-empty --format '%v%n' APT::Architecture APT::Architectures | sort -u | tr '\n' ' '
449 }
450
451 getarchitecturesfromcommalist() {
452 echo "$1" | sed -e 's#,#\n#g' | sed -e "s/^native\$/$(getarchitecture 'native')/"
453 }
454
455 configarchitecture() {
456 {
457 echo "APT::Architecture \"$(getarchitecture $1)\";"
458 while [ -n "$1" ]; do
459 echo "APT::Architectures:: \"$(getarchitecture $1)\";"
460 shift
461 done
462 } >rootdir/etc/apt/apt.conf.d/01multiarch.conf
463 configdpkg
464 }
465
466 configdpkg() {
467 if [ ! -e rootdir/var/lib/dpkg/status ]; then
468 local BASENAME="${0##*/}"
469 local STATUSFILE="status-${BASENAME#*-}"
470 if [ -f "${TESTDIRECTORY}/${STATUSFILE}" ]; then
471 cp "${TESTDIRECTORY}/${STATUSFILE}" rootdir/var/lib/dpkg/status
472 else
473 echo -n > rootdir/var/lib/dpkg/status
474 fi
475 fi
476 rm -f rootdir/etc/apt/apt.conf.d/00foreigndpkg
477 if command dpkg --assert-multi-arch >/dev/null 2>&1 ; then
478 local ARCHS="$(getarchitectures)"
479 if echo "$ARCHS" | grep -E -q '[^ ]+ [^ ]+'; then
480 DPKGARCH="$(dpkg --print-architecture)"
481 for ARCH in ${ARCHS}; do
482 if [ "${ARCH}" != "${DPKGARCH}" ]; then
483 if ! dpkg --add-architecture ${ARCH} >/dev/null 2>&1; then
484 # old-style used e.g. in Ubuntu-P – and as it seems travis
485 echo "DPKG::options:: \"--foreign-architecture\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
486 echo "DPKG::options:: \"${ARCH}\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
487 fi
488 fi
489 done
490 if [ "0" = "$(dpkg -l dpkg 2> /dev/null | grep '^i' | wc -l)" ]; then
491 # dpkg doesn't really check the version as long as it is fully installed,
492 # but just to be sure we choose one above the required version
493 insertinstalledpackage 'dpkg' "all" '1.16.2+fake'
494 fi
495 fi
496 fi
497 }
498
499 configdpkgnoopchroot() {
500 # create a library to noop chroot() and rewrite maintainer script executions
501 # via execvp() as used by dpkg as we don't want our rootdir to be a fullblown
502 # chroot directory dpkg could chroot into to execute the maintainer scripts
503 msgtest 'Building library to preload to make maintainerscript work in' 'dpkg'
504 cat > noopchroot.c << EOF
505 #define _GNU_SOURCE
506 #include <stdio.h>
507 #include <stdlib.h>
508 #include <string.h>
509 #include <dlfcn.h>
510
511 static char * chrootdir = NULL;
512
513 int chroot(const char *path) {
514 printf("WARNING: CHROOTing to %s was ignored!\n", path);
515 free(chrootdir);
516 chrootdir = strdup(path);
517 return 0;
518 }
519 int execvp(const char *file, char *const argv[]) {
520 static int (*func_execvp) (const char *, char * const []) = NULL;
521 if (func_execvp == NULL)
522 func_execvp = (int (*) (const char *, char * const [])) dlsym(RTLD_NEXT, "execvp");
523 if (chrootdir == NULL || strncmp(file, "/var/lib/dpkg/", strlen("/var/lib/dpkg/")) != 0)
524 return func_execvp(file, argv);
525 printf("REWRITE execvp call %s into %s\n", file, chrootdir);
526 char *newfile;
527 if (asprintf(&newfile, "%s%s", chrootdir, file) == -1) {
528 perror("asprintf");
529 return -1;
530 }
531 char const * const baseadmindir = "/var/lib/dpkg";
532 char *admindir;
533 if (asprintf(&admindir, "%s%s", chrootdir, baseadmindir) == -1) {
534 perror("asprintf");
535 return -1;
536 }
537 setenv("DPKG_ADMINDIR", admindir, 1);
538 return func_execvp(newfile, argv);
539 }
540 EOF
541 testempty --nomsg gcc -Wall -Wextra -fPIC -shared -o noopchroot.so noopchroot.c -ldl
542 }
543 configcompression() {
544 if [ "$1" = 'ALL' ]; then
545 configcompression '.' $(aptconfig dump APT::Compressor --format '%t %v%n' | sed -n 's#^Extension \.\(.*\)$#\1#p')
546 return
547 fi
548 local CMD='apthelper cat-file -C'
549 while [ -n "$1" ]; do
550 case "$1" in
551 '.') printf ".\t.\tcat\n";;
552 'gz') printf "gzip\tgz\t$CMD $1\n";;
553 'bz2') printf "bzip2\tbz2\t$CMD $1\n";;
554 *) printf "$1\t$1\t$CMD $1\n";;
555 esac
556 shift
557 done > "${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf"
558 }
559 confighashes() {
560 {
561 echo 'APT::FTPArchive {'
562 {
563 while [ -n "$1" ]; do
564 printf "$1" | tr 'a-z' 'A-Z'
565 printf "\t\"true\";\n"
566 shift
567 done
568 for h in 'MD5' 'SHA1' 'SHA256' 'SHA512'; do
569 printf "$h\t\"false\";\n"
570 done
571 } | awk '!x[$1]++'
572 echo '};'
573 } >> "${TMPWORKINGDIRECTORY}/rootdir/etc/apt/apt.conf.d/ftparchive-hashes.conf"
574 }
575 forcecompressor() {
576 COMPRESSOR="$1"
577 COMPRESS="$1"
578 COMPRESSOR_CMD="apthelper cat-file -C $1"
579 case $COMPRESSOR in
580 gzip) COMPRESS='gz';;
581 bzip2) COMPRESS='bz2';;
582 esac
583 local CONFFILE="${TMPWORKINGDIRECTORY}/rootdir/etc/apt/apt.conf.d/00force-compressor"
584 echo "Acquire::CompressionTypes::Order { \"${COMPRESS}\"; };
585 Dir::Bin::uncompressed \"/does/not/exist\";" > "$CONFFILE"
586 for COMP in $(aptconfig dump 'APT::Compressor' --format '%f%n' | cut -d':' -f 5 | uniq); do
587 if [ -z "$COMP" -o "$COMP" = '.' -o "$COMP" = "$COMPRESSOR" ]; then continue; fi
588 echo "Dir::Bin::${COMP} \"/does/not/exist\";" >> "$CONFFILE"
589 echo "APT::Compressor::${COMP}::Name \"${COMP}-disabled\";" >> "$CONFFILE"
590 done
591 }
592
593 setupsimplenativepackage() {
594 local NAME="$1"
595 local ARCH="$2"
596 local VERSION="$3"
597 local RELEASE="${4:-unstable}"
598 local DEPENDENCIES="$5"
599 local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
600 If you find such a package installed on your system,
601 something went horribly wrong! They are autogenerated
602 und used only by testcases and serve no other purpose…"}"
603
604 local SECTION="${7:-others}"
605 local DISTSECTION
606 if [ "$SECTION" = "${SECTION#*/}" ]; then
607 DISTSECTION="main"
608 else
609 DISTSECTION="${SECTION%/*}"
610 fi
611 local BUILDDIR=incoming/${NAME}-${VERSION}
612 mkdir -p ${BUILDDIR}/debian/source
613 cd ${BUILDDIR}
614 echo "* most suckless software product ever" > FEATURES
615 test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date -u +%Y)" > debian/copyright
616 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
617
618 * Initial release
619
620 -- Joe Sixpack <joe@example.org> $(date -u -R)" > debian/changelog
621 test -e debian/control || echo "Source: $NAME
622 Section: $SECTION
623 Priority: optional
624 Maintainer: Joe Sixpack <joe@example.org>
625 Build-Depends: debhelper (>= 7)
626 Standards-Version: 3.9.1
627
628 Package: $NAME" > debian/control
629 if [ "$ARCH" = 'all' ]; then
630 echo "Architecture: all" >> debian/control
631 else
632 echo "Architecture: any" >> debian/control
633 fi
634 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
635 echo "Description: $DESCRIPTION" >> debian/control
636
637 test -e debian/compat || echo "7" > debian/compat
638 test -e debian/source/format || echo "3.0 (native)" > debian/source/format
639 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
640 cd - > /dev/null
641 }
642
643 buildsimplenativepackage() {
644 local NAME="$1"
645 local NM
646 if [ "$(echo "$NAME" | cut -c 1-3)" = 'lib' ]; then
647 NM="$(echo "$NAME" | cut -c 1-4)"
648 else
649 NM="$(echo "$NAME" | cut -c 1)"
650 fi
651 local ARCH="$2"
652 local VERSION="$3"
653 local RELEASE="${4:-unstable}"
654 local DEPENDENCIES="$5"
655 local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
656 If you find such a package installed on your system,
657 something went horribly wrong! They are autogenerated
658 und used only by testcases and serve no other purpose…"}"
659
660 local SECTION="${7:-others}"
661 local PRIORITY="${8:-optional}"
662 local FILE_TREE="$9"
663 local COMPRESS_TYPE="${10:-gzip}"
664 local DISTSECTION
665 if [ "$SECTION" = "${SECTION#*/}" ]; then
666 DISTSECTION="main"
667 else
668 DISTSECTION="${SECTION%/*}"
669 fi
670 local BUILDDIR="${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}"
671
672 msgtest "Build source package in version ${VERSION} for ${RELEASE} in ${DISTSECTION}" "$NAME"
673 mkdir -p "$BUILDDIR/debian/source"
674 echo "* most suckless software product ever" > "${BUILDDIR}/FEATURES"
675 echo "#!/bin/sh
676 echo '$NAME says \"Hello!\"'" > "${BUILDDIR}/${NAME}"
677
678 echo "Copyleft by Joe Sixpack $(date -u +%Y)" > "${BUILDDIR}/debian/copyright"
679 echo "$NAME ($VERSION) $RELEASE; urgency=low
680
681 * Initial release
682
683 -- Joe Sixpack <joe@example.org> $(date -u -R)" > "${BUILDDIR}/debian/changelog"
684 {
685 echo "Source: $NAME
686 Priority: $PRIORITY
687 Maintainer: Joe Sixpack <joe@example.org>
688 Standards-Version: 3.9.3"
689 if [ "$SECTION" != '<none>' ]; then
690 echo "Section: $SECTION"
691 fi
692 local BUILDDEPS="$(echo "$DEPENDENCIES" | grep '^Build-')"
693 test -z "$BUILDDEPS" || echo "$BUILDDEPS"
694 echo "
695 Package: $NAME"
696
697 if [ "$ARCH" = 'all' ]; then
698 echo "Architecture: all"
699 else
700 echo "Architecture: any"
701 fi
702 local DEPS="$(echo "$DEPENDENCIES" | grep -v '^Build-')"
703 test -z "$DEPS" || echo "$DEPS"
704 echo "Description: $DESCRIPTION"
705 } > "${BUILDDIR}/debian/control"
706
707 echo '3.0 (native)' > "${BUILDDIR}/debian/source/format"
708 cd "${BUILDDIR}/.."
709 testsuccess --nomsg dpkg-source -b ${NAME}-${VERSION}
710 cd - >/dev/null
711 sed -n 's#^dpkg-source: info: building [^ ]\+ in ##p' "${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output" \
712 | while read SRC; do
713 echo "pool/${SRC}" >> "${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist"
714 # if expr match "${SRC}" '.*\.dsc' >/dev/null 2>&1; then
715 # aptkey --keyring ./keys/joesixpack.pub --secret-keyring ./keys/joesixpack.sec --quiet --readonly \
716 # adv --yes --default-key 'Joe Sixpack' \
717 # --clearsign -o "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC"
718 # mv "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC"
719 # fi
720 done
721
722 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
723 msgtest "Build binary package for ${RELEASE} in ${SECTION}" "$NAME"
724 rm -rf "${BUILDDIR}/debian/tmp"
725 mkdir -p "${BUILDDIR}/debian/tmp/DEBIAN" "${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}" "${BUILDDIR}/debian/tmp/usr/bin"
726 cp "${BUILDDIR}/debian/copyright" "${BUILDDIR}/debian/changelog" "${BUILDDIR}/FEATURES" "${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}"
727 cp "${BUILDDIR}/${NAME}" "${BUILDDIR}/debian/tmp/usr/bin/${NAME}-${arch}"
728 if [ -n "$FILE_TREE" ]; then
729 cp -ar "$FILE_TREE" "${BUILDDIR}/debian/tmp"
730 fi
731
732 (cd "${BUILDDIR}"; dpkg-gencontrol -DArchitecture=$arch)
733 (cd "${BUILDDIR}/debian/tmp"; md5sum $(find usr/ -type f) > DEBIAN/md5sums)
734 local LOG="${BUILDDIR}/../${NAME}_${VERSION}_${arch}.dpkg-deb.log"
735 # ensure the right permissions as dpkg-deb insists
736 chmod 755 "${BUILDDIR}/debian/tmp/DEBIAN"
737 testsuccess --nomsg dpkg-deb -Z${COMPRESS_TYPE} --build "${BUILDDIR}/debian/tmp" "${BUILDDIR}/.."
738 echo "pool/${NAME}_${VERSION}_${arch}.deb" >> "${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist"
739 done
740
741 local CHANGEPATH="${BUILDDIR}/../${DISTSECTION}/${NM}/${NAME}/${NAME}_${VERSION}"
742 mkdir -p "$CHANGEPATH"
743 cp "${BUILDDIR}/debian/changelog" "$CHANGEPATH"
744 rm -rf "${BUILDDIR}"
745 msgdone "info"
746 }
747
748 buildpackage() {
749 local BUILDDIR=$1
750 local RELEASE=$2
751 local SECTION=$3
752 local ARCH=$(getarchitecture $4)
753 local PKGNAME="$(echo "$BUILDDIR" | grep -o '[^/]*$')"
754 local BUILDLOG="$(readlink -f "${BUILDDIR}/../${PKGNAME}_${RELEASE}_${SECTION}.dpkg-bp.log")"
755 msgtest "Build package for ${RELEASE} in ${SECTION}" "$PKGNAME"
756 cd "$BUILDDIR"
757 if [ "$ARCH" = "all" ]; then
758 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
759 fi
760 testsuccess --nomsg dpkg-buildpackage -uc -us -a$ARCH
761 cp "${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output" "$BUILDLOG"
762 local PKGS="$(grep '^dpkg-deb: building package' "$BUILDLOG" | cut -d'/' -f 2 | sed -e "s#'\.##")"
763 local SRCS="$(grep '^dpkg-source: info: building' "$BUILDLOG" | grep -o '[a-z0-9._+~-]*$')"
764 cd - > /dev/null
765 for PKG in $PKGS; do
766 echo "pool/${PKG}" >> "${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist"
767 done
768 for SRC in $SRCS; do
769 echo "pool/${SRC}" >> "${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist"
770 done
771 }
772
773 buildaptarchive() {
774 if [ -d incoming ]; then
775 buildaptarchivefromincoming "$@"
776 else
777 buildaptarchivefromfiles "$@"
778 fi
779 }
780
781 createaptftparchiveconfig() {
782 local COMPRESSORS="$(cut -d' ' -f 1 "${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf" | tr '\n' ' ')"
783 local COMPRESSORS="${COMPRESSORS%* }"
784 local ARCHS="$(getarchitectures)"
785 cat > ftparchive.conf <<EOF
786 Dir {
787 ArchiveDir "$(readlink -f .)";
788 CacheDir "$(readlink -f ..)";
789 FileListDir "$(readlink -f pool/)";
790 };
791 Default {
792 Packages::Compress "$COMPRESSORS";
793 Sources::Compress "$COMPRESSORS";
794 Contents::Compress "$COMPRESSORS";
795 Translation::Compress "$COMPRESSORS";
796 LongDescription "false";
797 };
798 TreeDefault {
799 Directory "pool/";
800 SrcDirectory "pool/";
801 };
802 EOF
803 for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
804 cat <<EOF
805 tree "dists/$DIST" {
806 Architectures "$ARCHS all source";
807 FileList "${DIST}.\$(SECTION).pkglist";
808 SourceFileList "${DIST}.\$(SECTION).srclist";
809 Sections "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')";
810 };
811 EOF
812 done >> ftparchive.conf
813 }
814
815 buildaptftparchivedirectorystructure() {
816 local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
817 for DIST in $DISTS; do
818 local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
819 for SECTION in $SECTIONS; do
820 local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
821 for ARCH in $ARCHS; do
822 mkdir -p "dists/${DIST}/${SECTION}/binary-${ARCH}"
823 done
824 mkdir -p "dists/${DIST}/${SECTION}/source"
825 mkdir -p "dists/${DIST}/${SECTION}/i18n"
826 done
827 done
828 }
829
830 insertpackage() {
831 local RELEASES="$1"
832 local NAME="$2"
833 local ARCH="$3"
834 local VERSION="$4"
835 local DEPENDENCIES="$5"
836 local PRIORITY="${6:-optional}"
837 local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASES}
838 If you find such a package installed on your system,
839 something went horribly wrong! They are autogenerated
840 und used only by testcases and serve no other purpose…"}"
841 local ARCHS=""
842 for RELEASE in $(printf '%s' "$RELEASES" | tr ',' '\n'); do
843 if [ "$RELEASE" = 'installed' ]; then
844 insertinstalledpackage "$2" "$3" "$4" "$5" "$6" "$7"
845 continue
846 fi
847 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
848 if [ "$arch" = 'none' ]; then
849 ARCHS="$(getarchitectures)"
850 else
851 ARCHS="$arch"
852 fi
853 for BUILDARCH in $ARCHS; do
854 local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
855 mkdir -p "$PPATH"
856 {
857 echo "Package: $NAME
858 Priority: $PRIORITY
859 Section: other
860 Installed-Size: 42
861 Maintainer: Joe Sixpack <joe@example.org>"
862 test "$arch" = 'none' || echo "Architecture: $arch"
863 echo "Version: $VERSION
864 Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb"
865 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES"
866 echo "Description: $(printf '%s' "$DESCRIPTION" | head -n 1)"
867 echo "Description-md5: $(printf '%s' "$DESCRIPTION" | md5sum | cut -d' ' -f 1)"
868 echo
869 } >> "${PPATH}/Packages"
870 done
871 done
872 mkdir -p "aptarchive/dists/${RELEASE}/main/source" "aptarchive/dists/${RELEASE}/main/i18n"
873 touch "aptarchive/dists/${RELEASE}/main/source/Sources"
874 echo "Package: $NAME
875 Description-md5: $(printf '%s' "$DESCRIPTION" | md5sum | cut -d' ' -f 1)
876 Description-en: $DESCRIPTION
877 " >> "aptarchive/dists/${RELEASE}/main/i18n/Translation-en"
878 done
879 }
880
881 insertsource() {
882 local RELEASES="$1"
883 local NAME="$2"
884 local ARCH="$3"
885 local VERSION="$4"
886 local DEPENDENCIES="$5"
887 local BINARY="${6:-$NAME}"
888 local ARCHS=""
889 for RELEASE in $(printf '%s' "$RELEASES" | tr ',' '\n'); do
890 local SPATH="aptarchive/dists/${RELEASE}/main/source"
891 mkdir -p $SPATH
892 local FILE="${SPATH}/Sources"
893 local DSCFILE="${NAME}_${VERSION}.dsc"
894 local TARFILE="${NAME}_${VERSION}.tar.gz"
895 echo "Package: $NAME
896 Binary: $BINARY
897 Version: $VERSION
898 Maintainer: Joe Sixpack <joe@example.org>
899 Architecture: $ARCH" >> $FILE
900 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> "$FILE"
901 echo "Files:
902 $(echo -n "$DSCFILE" | md5sum | cut -d' ' -f 1) $(echo -n "$DSCFILE" | wc -c) "$DSCFILE"
903 $(echo -n "$TARFILE" | md5sum | cut -d' ' -f 1) $(echo -n "$TARFILE" | wc -c) "$TARFILE"
904 Checksums-Sha256:
905 $(echo -n "$DSCFILE" | sha256sum | cut -d' ' -f 1) $(echo -n "$DSCFILE" | wc -c) "$DSCFILE"
906 $(echo -n "$TARFILE" | sha256sum | cut -d' ' -f 1) $(echo -n "$TARFILE" | wc -c) "$TARFILE"
907 " >> "$FILE"
908 done
909 }
910
911 insertinstalledpackage() {
912 local NAME="$1"
913 local ARCH="$2"
914 local VERSION="$3"
915 local DEPENDENCIES="$4"
916 local PRIORITY="${5:-optional}"
917 local STATUS="${6:-install ok installed}"
918 local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/installed
919 If you find such a package installed on your system,
920 something went horribly wrong! They are autogenerated
921 und used only by testcases and serve no other purpose…"}"
922
923 local FILE='rootdir/var/lib/dpkg/status'
924 local INFO='rootdir/var/lib/dpkg/info'
925 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
926 echo "Package: $NAME
927 Status: $STATUS
928 Priority: $PRIORITY
929 Section: other
930 Installed-Size: 42
931 Maintainer: Joe Sixpack <joe@example.org>
932 Version: $VERSION" >> "$FILE"
933 test "$arch" = 'none' || echo "Architecture: $arch" >> "$FILE"
934 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> "$FILE"
935 echo "Description: $DESCRIPTION" >> "$FILE"
936 echo >> "$FILE"
937 if [ "$(dpkg-query -W --showformat='${Multi-Arch}')" = 'same' ]; then
938 echo -n > "${INFO}/${NAME}:${arch}.list"
939 else
940 echo -n > "${INFO}/${NAME}.list"
941 fi
942 done
943 }
944
945
946 buildaptarchivefromincoming() {
947 msginfo "Build APT archive for ${CCMD}${0##*/}${CINFO} based on incoming packages…"
948 cd aptarchive
949 [ -e pool ] || ln -s ../incoming pool
950 [ -e ftparchive.conf ] || createaptftparchiveconfig
951 [ -e dists ] || buildaptftparchivedirectorystructure
952 msgninfo "\tGenerate Packages, Sources and Contents files… "
953 testsuccess aptftparchive generate ftparchive.conf
954 cd - > /dev/null
955 msgdone "info"
956 generatereleasefiles "$@"
957 }
958
959 buildaptarchivefromfiles() {
960 msginfo "Build APT archive for ${CCMD}${0##*/}${CINFO} based on prebuild files…"
961 local DIR='aptarchive'
962 if [ -d "${DIR}/dists" ]; then DIR="${DIR}/dists"; fi
963 find "$DIR" -name 'Packages' -o -name 'Sources' -o -name 'Translation-*' | while read line; do
964 msgninfo "\t${line} file"
965 compressfile "$line" "$1"
966 msgdone "info"
967 done
968 generatereleasefiles "$@"
969 }
970
971 compressfile() {
972 while read compressor extension command; do
973 if [ "$compressor" = '.' ]; then
974 if [ -n "$2" ]; then
975 touch -d "$2" "$1"
976 fi
977 continue
978 fi
979 cat "$1" | $command > "${1}.${extension}"
980 if [ -n "$2" ]; then
981 touch -d "$2" "${1}.${extension}"
982 fi
983 done < "${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf"
984 }
985
986 # can be overridden by testcases for their pleasure
987 getcodenamefromsuite() {
988 case "$1" in
989 unstable) echo 'sid';;
990 *) echo -n "$1";;
991 esac
992 }
993 getreleaseversionfromsuite() { true; }
994 getlabelfromsuite() { true; }
995 getoriginfromsuite() { true; }
996 getarchitecturesfromreleasefile() { echo "all $(getarchitectures)"; }
997
998 aptftparchiverelease() {
999 aptftparchive -qq release "$@" | sed -e '/0 Release$/ d' # remove the self reference
1000 }
1001 generatereleasefiles() {
1002 # $1 is the Date header and $2 is the ValidUntil header to be set
1003 # both should be given in notation date/touch can understand
1004 local DATE="$1"
1005 local VALIDUNTIL="$2"
1006 if [ -e aptarchive/dists ]; then
1007 msgninfo "\tGenerate Release files for dists… "
1008 for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
1009 local ARCHITECTURES="$(getarchitecturesfromreleasefile "$dir")"
1010 local SUITE="$(echo "$dir" | cut -d'/' -f 4)"
1011 local CODENAME="$(getcodenamefromsuite $SUITE)"
1012 local VERSION="$(getreleaseversionfromsuite $SUITE)"
1013 local LABEL="$(getlabelfromsuite $SUITE)"
1014 local ORIGIN="$(getoriginfromsuite $SUITE)"
1015 aptftparchiverelease "$dir" \
1016 -o APT::FTPArchive::Release::Suite="${SUITE}" \
1017 -o APT::FTPArchive::Release::Codename="${CODENAME}" \
1018 -o APT::FTPArchive::Release::Architectures="${ARCHITECTURES}" \
1019 -o APT::FTPArchive::Release::Label="${LABEL}" \
1020 -o APT::FTPArchive::Release::Origin="${ORIGIN}" \
1021 -o APT::FTPArchive::Release::Version="${VERSION}" \
1022 > "$dir/Release"
1023 if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then
1024 sed -i '/^Date: / a\
1025 NotAutomatic: yes' "$dir/Release"
1026 fi
1027 done
1028 else
1029 msgninfo "\tGenerate Release files for flat… "
1030 aptftparchiverelease ./aptarchive > aptarchive/Release
1031 fi
1032 if [ -n "$DATE" -a "$DATE" != "now" ]; then
1033 for release in $(find ./aptarchive -name 'Release'); do
1034 sed -i "s/^Date: .*$/Date: $(date -u -d "$DATE" '+%a, %d %b %Y %H:%M:%S %Z')/" "$release"
1035 touch -d "$DATE" "$release"
1036 done
1037 fi
1038 if [ -n "$VALIDUNTIL" ]; then
1039 sed -i "/^Date: / a\
1040 Valid-Until: $(date -u -d "$VALIDUNTIL" '+%a, %d %b %Y %H:%M:%S %Z')" $(find ./aptarchive -name 'Release')
1041 fi
1042 msgdone "info"
1043 }
1044
1045 setupdistsaptarchive() {
1046 local APTARCHIVE="$(readlink -f ./aptarchive | sed 's# #%20#g')"
1047 rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
1048 rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
1049 for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
1050 SECTIONS=$(find "./aptarchive/dists/${DISTS}/" -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
1051 msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}"
1052 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > "rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list"
1053 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > "rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list"
1054 msgdone "info"
1055 done
1056 }
1057
1058 setupflataptarchive() {
1059 local APTARCHIVE="$(readlink -f ./aptarchive)"
1060 local APTARCHIVEURI="$(readlink -f ./aptarchive | sed 's# #%20#g')"
1061 if [ -f "${APTARCHIVE}/Packages" ]; then
1062 msgninfo "\tadd deb sources.list line… "
1063 echo "deb file://$APTARCHIVEURI /" > 'rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list'
1064 msgdone 'info'
1065 else
1066 rm -f 'rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list'
1067 fi
1068 if [ -f "${APTARCHIVE}/Sources" ]; then
1069 msgninfo "\tadd deb-src sources.list line… "
1070 echo "deb-src file://$APTARCHIVEURI /" > 'rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list'
1071 msgdone 'info'
1072 else
1073 rm -f 'rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list'
1074 fi
1075 }
1076
1077 setupaptarchive() {
1078 local NOUPDATE=0
1079 if [ "$1" = '--no-update' ]; then
1080 NOUPDATE=1
1081 shift
1082 fi
1083 buildaptarchive "$@"
1084 if [ -e aptarchive/dists ]; then
1085 setupdistsaptarchive
1086 else
1087 setupflataptarchive
1088 fi
1089 signreleasefiles 'Joe Sixpack'
1090 if [ "1" != "$NOUPDATE" ]; then
1091 testsuccess aptget update -o Debug::pkgAcquire::Worker=true -o Debug::Acquire::gpgv=true
1092 fi
1093 }
1094
1095 signreleasefiles() {
1096 local SIGNERS="${1:-Joe Sixpack}"
1097 local REPODIR="${2:-aptarchive}"
1098 if [ -n "$1" ]; then shift; fi
1099 if [ -n "$1" ]; then shift; fi
1100 local KEY="keys/$(echo "$SIGNERS" | tr 'A-Z' 'a-z' | tr -d ' ,')"
1101 msgninfo "\tSign archive with $SIGNERS key $KEY"
1102 local REXKEY='keys/rexexpired'
1103 local SECEXPIREBAK="${REXKEY}.sec.bak"
1104 local PUBEXPIREBAK="${REXKEY}.pub.bak"
1105 local SIGUSERS=""
1106 while [ -n "${SIGNERS%%,*}" ]; do
1107 local SIGNER="${SIGNERS%%,*}"
1108 if [ "${SIGNERS}" = "${SIGNER}" ]; then
1109 SIGNERS=""
1110 fi
1111 SIGNERS="${SIGNERS#*,}"
1112 # FIXME: This should be the full name, but we can't encode the space properly currently
1113 SIGUSERS="${SIGUSERS} -u ${SIGNER#* }"
1114 if [ "${SIGNER}" = 'Rex Expired' ]; then
1115 # the key is expired, so gpg doesn't allow to sign with and the --faked-system-time
1116 # option doesn't exist anymore (and using faketime would add a new obscure dependency)
1117 # therefore we 'temporary' make the key not expired and restore a backup after signing
1118 cp "${REXKEY}.sec" "$SECEXPIREBAK"
1119 cp "${REXKEY}.pub" "$PUBEXPIREBAK"
1120 local SECUNEXPIRED="${REXKEY}.sec.unexpired"
1121 local PUBUNEXPIRED="${REXKEY}.pub.unexpired"
1122 if [ -f "$SECUNEXPIRED" ] && [ -f "$PUBUNEXPIRED" ]; then
1123 cp "$SECUNEXPIRED" "${REXKEY}.sec"
1124 cp "$PUBUNEXPIRED" "${REXKEY}.pub"
1125 else
1126 if ! printf "expire\n1w\nsave\n" | aptkey --quiet --keyring "${REXKEY}.pub" --secret-keyring "${REXKEY}.sec" \
1127 --readonly adv --batch --yes --digest-algo "${APT_TESTS_DIGEST_ALGO:-SHA512}" \
1128 --default-key "$SIGNER" --command-fd 0 --edit-key "${SIGNER}" >setexpire.gpg 2>&1; then
1129 cat setexpire.gpg
1130 exit 1
1131 fi
1132 cp "${REXKEY}.sec" "$SECUNEXPIRED"
1133 cp "${REXKEY}.pub" "$PUBUNEXPIRED"
1134 fi
1135 fi
1136 if [ ! -e "${KEY}.pub" ]; then
1137 local K="keys/$(echo "$SIGNER" | tr 'A-Z' 'a-z' | tr -d ' ,')"
1138 cat "${K}.pub" >> "${KEY}.new.pub"
1139 cat "${K}.sec" >> "${KEY}.new.sec"
1140 fi
1141 done
1142 if [ ! -e "${KEY}.pub" ]; then
1143 mv "${KEY}.new.pub" "${KEY}.pub"
1144 mv "${KEY}.new.sec" "${KEY}.sec"
1145 fi
1146 local GPG="aptkey --quiet --keyring ${KEY}.pub --secret-keyring ${KEY}.sec --readonly adv --batch --yes --digest-algo ${APT_TESTS_DIGEST_ALGO:-SHA512}"
1147 for RELEASE in $(find "${REPODIR}/" -name Release); do
1148 # we might have set a specific date for the Release file, so copy it
1149 local DATE="$(stat --format "%y" "${RELEASE}")"
1150 if [ "$APT_DONT_SIGN" = 'Release.gpg' ]; then
1151 rm -f "${RELEASE}.gpg"
1152 else
1153 testsuccess $GPG "$@" $SIGUSERS --armor --detach-sign --sign --output "${RELEASE}.gpg" "${RELEASE}"
1154 touch -d "$DATE" "${RELEASE}.gpg"
1155 fi
1156 local INRELEASE="${RELEASE%/*}/InRelease"
1157 if [ "$APT_DONT_SIGN" = 'InRelease' ]; then
1158 rm -f "$INRELEASE"
1159 else
1160 testsuccess $GPG "$@" $SIGUSERS --clearsign --output "$INRELEASE" "$RELEASE"
1161 touch -d "$DATE" "${INRELEASE}"
1162 fi
1163 done
1164 if [ -f "$SECEXPIREBAK" ] && [ -f "$PUBEXPIREBAK" ]; then
1165 mv -f "$SECEXPIREBAK" "${REXKEY}.sec"
1166 mv -f "$PUBEXPIREBAK" "${REXKEY}.pub"
1167 fi
1168 msgdone 'info'
1169 }
1170
1171 redatereleasefiles() {
1172 local DATE="$(date -u -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')"
1173 for release in $(find aptarchive/ -name 'Release'); do
1174 sed -i "s/^Date: .*$/Date: ${DATE}/" "$release"
1175 touch -d "$DATE" "$release"
1176 done
1177 signreleasefiles "${2:-Joe Sixpack}"
1178 }
1179
1180 webserverconfig() {
1181 local WEBSERVER="${3:-http://localhost:${APTHTTPPORT}}"
1182 local NOCHECK=false
1183 if [ "$1" = '--no-check' ]; then
1184 NOCHECK=true
1185 shift
1186 fi
1187 local DOWNLOG='rootdir/tmp/download-testfile.log'
1188 local STATUS='downloaded/webserverconfig.status'
1189 rm -f "$STATUS" "$DOWNLOG"
1190 # very very basic URI encoding
1191 local URI
1192 if [ -n "$2" ]; then
1193 msgtest "Set webserver config option '${1}' to" "$2"
1194 URI="${WEBSERVER}/_config/set/$(echo "${1}" | sed -e 's/\//%2f/g')/$(echo "${2}" | sed -e 's/\//%2f/g')"
1195 else
1196 msgtest 'Clear webserver config option' "${1}"
1197 URI="${WEBSERVER}/_config/clear/$(echo "${1}" | sed -e 's/\//%2f/g')"
1198 fi
1199 if downloadfile "$URI" "$STATUS" > "$DOWNLOG"; then
1200 msgpass
1201 else
1202 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/webserverconfig.output"
1203 cat "$DOWNLOG" "$STATUS" >"$OUTPUT" 2>&1 || true
1204 msgfailoutput '' "$OUTPUT"
1205 fi
1206 $NOCHECK || testwebserverlaststatuscode '200'
1207 }
1208
1209 rewritesourceslist() {
1210 local APTARCHIVE="file://$(readlink -f "${TMPWORKINGDIRECTORY}/aptarchive" | sed 's# #%20#g')"
1211 local APTARCHIVE2="copy://$(readlink -f "${TMPWORKINGDIRECTORY}/aptarchive" | sed 's# #%20#g')"
1212 for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
1213 sed -i $LIST -e "s#$APTARCHIVE#${1}#" -e "s#$APTARCHIVE2#${1}#" \
1214 -e "s#http://[^@]*@\?localhost:${APTHTTPPORT}/\?#${1}#" \
1215 -e "s#https://[^@]*@\?localhost:${APTHTTPSPORT}/\?#${1}#"
1216 done
1217 }
1218
1219 # wait for up to 10s for a pid file to appear to avoid possible race
1220 # when a helper is started and dosn't write the PID quick enough
1221 waitforpidfile() {
1222 local PIDFILE="$1"
1223 for i in $(seq 10); do
1224 if test -s "$PIDFILE"; then
1225 return 0
1226 fi
1227 sleep 1
1228 done
1229 msgdie "waiting for $PIDFILE failed"
1230 return 1
1231 }
1232
1233 changetowebserver() {
1234 local REWRITE='no'
1235 if [ "$1" != '--no-rewrite' ]; then
1236 REWRITE='yes'
1237 else
1238 shift
1239 fi
1240 if test -x "${APTWEBSERVERBINDIR}/aptwebserver"; then
1241 cd aptarchive
1242 local LOG="webserver.log"
1243 if ! aptwebserver --port 0 -o aptwebserver::fork=1 -o aptwebserver::portfile='aptwebserver.port' "$@" >$LOG 2>&1 ; then
1244 cat "$LOG"
1245 false
1246 fi
1247 waitforpidfile aptwebserver.pid
1248 local PID="$(cat aptwebserver.pid)"
1249 if [ -z "$PID" ]; then
1250 msgdie 'Could not fork aptwebserver successfully'
1251 fi
1252 addtrap "kill $PID;"
1253 waitforpidfile aptwebserver.port
1254 APTHTTPPORT="$(cat aptwebserver.port)"
1255 if [ -z "$APTHTTPPORT" ]; then
1256 msgdie 'Could not get port for aptwebserver successfully'
1257 fi
1258 cd - > /dev/null
1259 else
1260 msgdie 'You have to build apt from source to have test/interactive-helper/aptwebserver available for tests requiring a webserver'
1261 fi
1262 if [ "$REWRTE" != 'yes' ]; then
1263 rewritesourceslist "http://localhost:${APTHTTPPORT}/"
1264 fi
1265 }
1266
1267 changetohttpswebserver() {
1268 if ! command -v stunnel4 >/dev/null 2>&1; then
1269 msgdie 'You need to install stunnel4 for https testcases'
1270 fi
1271 if [ ! -e "${TMPWORKINGDIRECTORY}/aptarchive/aptwebserver.pid" ]; then
1272 changetowebserver --no-rewrite "$@"
1273 fi
1274 echo "pid = ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid
1275 cert = ${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem
1276 output = /dev/null
1277
1278 [https]
1279 accept = 0
1280 connect = $APTHTTPPORT
1281 " > "${TMPWORKINGDIRECTORY}/stunnel.conf"
1282 stunnel4 "${TMPWORKINGDIRECTORY}/stunnel.conf"
1283 waitforpidfile "${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid"
1284 local PID="$(cat "${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid")"
1285 if [ -z "$PID" ]; then
1286 msgdie 'Could not fork stunnel4 successfully'
1287 fi
1288 addtrap 'prefix' "kill ${PID};"
1289 APTHTTPSPORT="$(lsof -i -n | awk "/^stunnel4 / && \$2 == \"${PID}\" {print \$9; exit; }" | cut -d':' -f 2)"
1290 webserverconfig 'aptwebserver::port::https' "$APTHTTPSPORT" "https://localhost:${APTHTTPSPORT}"
1291 rewritesourceslist "https://localhost:${APTHTTPSPORT}/"
1292 }
1293
1294 changetocdrom() {
1295 mkdir -p rootdir/media/cdrom/.disk
1296 local CD="$(readlink -f rootdir/media/cdrom)"
1297 cat > rootdir/etc/apt/apt.conf.d/00cdrom <<EOF
1298 acquire::cdrom::mount "${CD}";
1299 acquire::cdrom::"${CD}/"::mount "mv ${CD}-unmounted ${CD}";
1300 acquire::cdrom::"${CD}/"::umount "mv ${CD} ${CD}-unmounted";
1301 acquire::cdrom::autodetect 0;
1302 EOF
1303 echo -n "$1" > "${CD}/.disk/info"
1304 if [ ! -d aptarchive/dists ]; then
1305 msgdie 'Flat file archive cdroms can not be created currently'
1306 return 1
1307 fi
1308 mv aptarchive/dists "$CD"
1309 ln -s "$(readlink -f ./incoming)" "$CD/pool"
1310 find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list' -delete
1311 # start with an unmounted disk
1312 mv "${CD}" "${CD}-unmounted"
1313 # we don't want the disk to be modifiable
1314 addtrap 'prefix' "chmod -f -R +w '$(escape_shell "$PWD/rootdir/media/cdrom/dists/")' '$(escape_shell "$PWD/rootdir/media/cdrom-unmounted/dists/")' || true;"
1315 chmod -R 555 rootdir/media/cdrom-unmounted/dists
1316 }
1317
1318 downloadfile() {
1319 local PROTO="${1%%:*}"
1320 if ! apthelper -o Debug::Acquire::${PROTO}=1 -o Debug::pkgAcquire::Worker=1 \
1321 download-file "$1" "$2" "$3" 2>&1 ; then
1322 return 1
1323 fi
1324 # only if the file exists the download was successful
1325 if [ -r "$2" ]; then
1326 return 0
1327 else
1328 return 1
1329 fi
1330 }
1331
1332 checkdiff() {
1333 local DIFFTEXT="$(command diff -u "$@" 2>&1 | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
1334 if [ -n "$DIFFTEXT" ]; then
1335 echo >&2
1336 echo >&2 "$DIFFTEXT"
1337 return 1
1338 else
1339 return 0
1340 fi
1341 }
1342
1343 testoutputequal() {
1344 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testoutputequal.output"
1345 local COMPAREFILE="$1"
1346 shift
1347 if "$@" 2>&1 | checkdiff "$COMPAREFILE" - >"$OUTPUT" 2>&1; then
1348 msgpass
1349 else
1350 echo "=== content of file we compared with (${COMPAREFILE}) ===" >>"${OUTPUT}"
1351 cat "$COMPAREFILE" >>"${OUTPUT}"
1352 msgfailoutput '' "$OUTPUT" "$@"
1353 fi
1354 }
1355
1356 testfileequal() {
1357 msggroup 'testfileequal'
1358 local MSG='Test for correctness of file'
1359 if [ "$1" = '--nomsg' ]; then
1360 MSG=''
1361 shift
1362 fi
1363 local FILE="$1"
1364 shift
1365 if [ -n "$MSG" ]; then
1366 msgtest "$MSG" "$FILE"
1367 fi
1368 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfileequal.output"
1369 if [ -z "$*" ]; then
1370 testoutputequal "$FILE" echo -n ''
1371 else
1372 testoutputequal "$FILE" echo "$*"
1373 fi
1374 msggroup
1375 }
1376
1377 testempty() {
1378 msggroup 'testempty'
1379 if [ "$1" = '--nomsg' ]; then
1380 shift
1381 else
1382 msgtest "Test for no output of" "$*"
1383 fi
1384 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testempty.comparefile"
1385 if "$@" >"$COMPAREFILE" 2>&1 && test ! -s "$COMPAREFILE"; then
1386 msgpass
1387 else
1388 msgfailoutput '' "$COMPAREFILE" "$@"
1389 fi
1390 aptautotest 'testempty' "$@"
1391 msggroup
1392 }
1393 testnotempty() {
1394 msggroup 'testnotempty'
1395 msgtest "Test for some output of" "$*"
1396 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnotempty.comparefile"
1397 if ("$@" >"$COMPAREFILE" 2>&1 || true) && test -s "$COMPAREFILE"; then
1398 msgpass
1399 else
1400 msgfailoutput '' "$COMPAREFILE" "$@"
1401 fi
1402 aptautotest 'testnotempty' "$@"
1403 msggroup
1404 }
1405
1406 testequal() {
1407 msggroup 'testequal'
1408 local MSG='Test of equality of'
1409 if [ "$1" = '--nomsg' ]; then
1410 MSG=''
1411 shift
1412 fi
1413
1414 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.comparefile"
1415 echo "$1" > "$COMPAREFILE"
1416 shift
1417
1418 if [ -n "$MSG" ]; then
1419 msgtest "$MSG" "$*"
1420 fi
1421 testoutputequal "$COMPAREFILE" "$@"
1422 aptautotest 'testequal' "$@"
1423 msggroup
1424 }
1425
1426 testequalor2() {
1427 msggroup 'testequalor2'
1428 local COMPAREFILE1="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile1"
1429 local COMPAREFILE2="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile2"
1430 local COMPAREAGAINST="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.compareagainst"
1431 echo "$1" > "$COMPAREFILE1"
1432 echo "$2" > "$COMPAREFILE2"
1433 shift 2
1434 msgtest "Test for equality OR of" "$*"
1435 "$@" >"$COMPAREAGAINST" 2>&1 || true
1436 if checkdiff "$COMPAREFILE1" "$COMPAREAGAINST" >/dev/null 2>&1 || \
1437 checkdiff "$COMPAREFILE2" "$COMPAREAGAINST" >/dev/null 2>&1
1438 then
1439 msgpass
1440 else
1441 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.output"
1442 echo -n "\n${CINFO}Diff against OR 1${CNORMAL}" >"$OUTPUT" 2>&1
1443 checkdiff "$COMPAREFILE1" "$COMPAREAGAINST" >"$OUTPUT" 2>&1 || true
1444 echo -n "${CINFO}Diff against OR 2${CNORMAL}" >"$OUTPUT" 2>&1
1445 checkdiff "$COMPAREFILE2" "$COMPAREAGAINST" >"$OUTPUT" 2>&1 || true
1446 msgfailoutput '' "$OUTPUT"
1447 fi
1448 aptautotest 'testequalor2' "$@"
1449 msggroup
1450 }
1451
1452 testshowvirtual() {
1453 msggroup 'testshowvirtual'
1454 local VIRTUAL="N: Can't select versions from package '$1' as it is purely virtual"
1455 local PACKAGE="$1"
1456 shift
1457 while [ -n "$1" ]; do
1458 VIRTUAL="${VIRTUAL}
1459 N: Can't select versions from package '$1' as it is purely virtual"
1460 PACKAGE="${PACKAGE} $1"
1461 shift
1462 done
1463 msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
1464 VIRTUAL="${VIRTUAL}
1465 N: No packages found"
1466 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testshowvirtual.comparefile"
1467 local ARCH="$(getarchitecture 'native')"
1468 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' >"$COMPAREFILE"
1469 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testshowvirtual.output"
1470 testoutputequal "$COMPAREFILE" aptcache show "$PACKAGE"
1471 msggroup
1472 }
1473
1474 testnopackage() {
1475 msggroup 'testnopackage'
1476 msgtest "Test for non-existent packages" "apt-cache show $*"
1477 local SHOWPKG="$(aptcache show "$@" 2>&1 | grep '^Package: ')"
1478 if [ -n "$SHOWPKG" ]; then
1479 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnopackage.output"
1480 echo "$SHOWPKG" >"$OUTPUT"
1481 msgfailoutput '' "$OUTPUT"
1482 else
1483 msgpass
1484 fi
1485 msggroup
1486 }
1487 testnosrcpackage() {
1488 msggroup 'testnosrcpackage'
1489 msgtest "Test for non-existent source packages" "apt-cache showsrc $*"
1490 local SHOWPKG="$(aptcache showsrc "$@" 2>&1 | grep '^Package: ')"
1491 if [ -n "$SHOWPKG" ]; then
1492 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnosrcpackage.output"
1493 echo "$SHOWPKG" >"$OUTPUT"
1494 msgfailoutput '' "$OUTPUT"
1495 else
1496 msgpass
1497 fi
1498 msggroup
1499 }
1500
1501 testdpkgstatus() {
1502 msggroup 'testdpkgstatus'
1503 local STATE="$1"
1504 local NR="$2"
1505 shift 2
1506 msgtest "Test that $NR package(s) are in state $STATE with" "dpkg -l $*"
1507 local PKGS="$(dpkg -l "$@" 2>/dev/null | grep "^${STATE}" | wc -l)"
1508 if [ "$PKGS" != $NR ]; then
1509 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnopackage.output"
1510 echo "$PKGS" >"$OUTPUT"
1511 dpkg -l "$@" | grep '^[a-z]' >"$OUTPUT" >&2 || true
1512 msgfailoutput '' "$OUTPUT"
1513 else
1514 msgpass
1515 fi
1516 msggroup
1517 }
1518
1519 testdpkginstalled() {
1520 msggroup 'testdpkginstalled'
1521 testdpkgstatus 'ii' "$#" "$@"
1522 msggroup
1523 }
1524
1525 testdpkgnotinstalled() {
1526 msggroup 'testdpkgnotinstalled'
1527 testdpkgstatus 'ii' '0' "$@"
1528 msggroup
1529 }
1530
1531 testmarkedauto() {
1532 msggroup 'testmarkedauto'
1533 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedauto.comparefile"
1534 if [ -n "$1" ]; then
1535 msgtest 'Test for correctly marked as auto-installed' "$*"
1536 while [ -n "$1" ]; do echo "$1"; shift; done | sort > "$COMPAREFILE"
1537 else
1538 msgtest 'Test for correctly marked as auto-installed' 'no package'
1539 echo -n > "$COMPAREFILE"
1540 fi
1541 testoutputequal "$COMPAREFILE" aptmark showauto
1542 msggroup
1543 }
1544 testmarkedmanual() {
1545 msggroup 'testmarkedmanual'
1546 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedmanual.comparefile"
1547 if [ -n "$1" ]; then
1548 msgtest 'Test for correctly marked as manually installed' "$*"
1549 while [ -n "$1" ]; do echo "$1"; shift; done | sort > "$COMPAREFILE"
1550 else
1551 msgtest 'Test for correctly marked as manually installed' 'no package'
1552 echo -n > "$COMPAREFILE"
1553 fi
1554 testoutputequal "$COMPAREFILE" aptmark showmanual
1555 msggroup
1556 }
1557
1558 catfile() {
1559 if [ "${1##*.}" = 'deb' ]; then
1560 stat >&2 "$1" || true
1561 file >&2 "$1" || true
1562 else
1563 cat >&2 "$1" || true
1564 fi
1565 }
1566 msgfailoutput() {
1567 msgreportheader 'msgfailoutput'
1568 local MSG="$1"
1569 local OUTPUT="$2"
1570 shift 2
1571 if [ "$1" = 'grep' ]; then
1572 echo >&2
1573 while [ -n "$2" ]; do shift; done
1574 echo "#### Complete file: $1 ####"
1575 catfile "$1"
1576 echo '#### grep output ####'
1577 elif [ "$1" = 'test' ]; then
1578 echo >&2
1579 # doesn't support ! or non-file flags
1580 msgfailoutputstatfile() {
1581 local FILEFLAGS='^-[bcdefgGhkLOprsStuwx]$'
1582 if expr match "$1" "$FILEFLAGS" >/dev/null; then
1583 echo "#### stat(2) of file: $2 ####"
1584 stat "$2" || true
1585 if test -d "$2"; then
1586 echo "#### The directory contains: $2 ####"
1587 ls >&2 "$2" || true
1588 elif test -e "$2"; then
1589 echo "#### Complete file: $2 ####"
1590 catfile "$2"
1591 fi
1592 fi
1593 }
1594 msgfailoutputstatfile "$2" "$3"
1595 while [ -n "$5" ] && [ "$4" = '-o' -o "$4" = '-a' ]; do
1596 shift 3
1597 msgfailoutputstatfile "$2" "$3"
1598 done
1599 echo '#### test output ####'
1600 elif [ "$1" = 'cmp' ]; then
1601 echo >&2
1602 while [ -n "$2" ]; do
1603 echo "#### Complete file: $2 ####"
1604 catfile "$2"
1605 shift
1606 done
1607 echo '#### cmp output ####'
1608 fi
1609 catfile "$OUTPUT"
1610 msgfail "$MSG"
1611 }
1612
1613 testsuccesswithglobalerror() {
1614 local TYPE="$1"
1615 local ERRORS="$2"
1616 shift 2
1617 msggroup "$TYPE"
1618 if [ "$1" = '--nomsg' ]; then
1619 shift
1620 else
1621 msgtest 'Test for successful execution of' "$*"
1622 fi
1623 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/${TYPE}.output"
1624 if "$@" >"${OUTPUT}" 2>&1; then
1625 if expr match "$1" '^apt.*' >/dev/null; then
1626 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1627 msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
1628 elif grep -E "^[${ERRORS}]: " "$OUTPUT" > "${TMPWORKINGDIRECTORY}/rootdir/tmp/checkforwarnings.output" 2>&1; then
1629 if [ "$IGNORE_PTY_NOT_MOUNTED" = '1' ]; then
1630 if echo 'E: Can not write log (Is /dev/pts mounted?) - posix_openpt (2: No such file or directory)' \
1631 | cmp - "${TMPWORKINGDIRECTORY}/rootdir/tmp/checkforwarnings.output" >/dev/null 2>&1; then
1632 msgpass
1633 else
1634 msgfailoutput 'successful run, but output contains warnings/errors' "$OUTPUT" "$@"
1635 fi
1636 else
1637 msgfailoutput 'successful run, but output contains warnings/errors' "$OUTPUT" "$@"
1638 fi
1639 elif [ "$TYPE" = 'testsuccesswithnotice' ]; then
1640 if grep -q -E "^N: " "$OUTPUT"; then
1641 msgpass
1642 else
1643 msgfailoutput 'successful run, but output had no notices' "$OUTPUT" "$@"
1644 fi
1645 else
1646 msgpass
1647 fi
1648 else
1649 msgpass
1650 fi
1651 else
1652 local EXITCODE=$?
1653 msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@"
1654 fi
1655 aptautotest "$TYPE" "$@"
1656 msggroup
1657 }
1658 testsuccesswithnotice() {
1659 testsuccesswithglobalerror 'testsuccesswithnotice' 'WE' "$@"
1660 }
1661 testsuccess() {
1662 testsuccesswithglobalerror 'testsuccess' 'NWE' "$@"
1663 }
1664 testwarning() {
1665 msggroup 'testwarning'
1666 if [ "$1" = '--nomsg' ]; then
1667 shift
1668 else
1669 msgtest 'Test for successful execution with warnings of' "$*"
1670 fi
1671 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testwarning.output"
1672 if "$@" >"${OUTPUT}" 2>&1; then
1673 if expr match "$1" '^apt.*' >/dev/null; then
1674 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1675 msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
1676 elif grep -q -E '^E: ' "$OUTPUT"; then
1677 msgfailoutput 'successful run, but output contains errors' "$OUTPUT" "$@"
1678 elif ! grep -q -E '^W: ' "$OUTPUT"; then
1679 msgfailoutput 'successful run, but output contains no warnings' "$OUTPUT" "$@"
1680 else
1681 msgpass
1682 fi
1683 else
1684 msgpass
1685 fi
1686 else
1687 local EXITCODE=$?
1688 msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@"
1689 fi
1690 aptautotest 'testwarning' "$@"
1691 msggroup
1692 }
1693 testfailure() {
1694 msggroup 'testfailure'
1695 if [ "$1" = '--nomsg' ]; then
1696 shift
1697 else
1698 msgtest 'Test for failure in execution of' "$*"
1699 fi
1700 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output"
1701 if "$@" >"${OUTPUT}" 2>&1; then
1702 local EXITCODE=$?
1703 msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@"
1704 else
1705 local EXITCODE=$?
1706 if expr match "$1" '^apt.*' >/dev/null; then
1707 if [ "$1" = 'aptkey' ]; then
1708 if grep -q " Can't check signature:
1709 BAD signature from
1710 signature could not be verified" "$OUTPUT"; then
1711 msgpass
1712 else
1713 msgfailoutput "run failed with exitcode ${EXITCODE}, but no signature error" "$OUTPUT" "$@"
1714 fi
1715 else
1716 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1717 msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
1718 elif grep -q -E '==ERROR' "$OUTPUT"; then
1719 msgfailoutput 'compiler sanitizers reported errors' "$OUTPUT" "$@"
1720 elif ! grep -q -E '^E: ' "$OUTPUT"; then
1721 msgfailoutput "run failed with exitcode ${EXITCODE}, but with no errors" "$OUTPUT" "$@"
1722 else
1723 msgpass
1724 fi
1725 fi
1726 else
1727 msgpass
1728 fi
1729 fi
1730 aptautotest 'testfailure' "$@"
1731 msggroup
1732 }
1733
1734 testreturnstateequal() {
1735 local STATE="$1"
1736 if [ "$STATE" = 'testsuccesswithglobalerror' ]; then
1737 local STATE="$2"
1738 local TYPE="$3"
1739 shift 3
1740 msggroup "${STATE}equal"
1741 if [ "$1" != '--nomsg' ]; then
1742 local CMP="$1"
1743 shift
1744 testsuccesswithglobalerror "$STATE" "$TYPE" "$@"
1745 testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/${STATE}.output" "$CMP"
1746 else
1747 local CMP="$2"
1748 shift 2
1749 testsuccesswithglobalerror "$STATE" "$TYPE" "$@"
1750 testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/${STATE}.output" "$CMP"
1751 fi
1752 else
1753 msggroup "${STATE}equal"
1754 if [ "$2" != '--nomsg' ]; then
1755 local CMP="$2"
1756 shift 2
1757 "$STATE" "$@"
1758 testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/${STATE}.output" "$CMP"
1759 else
1760 local CMP="$3"
1761 shift 3
1762 "$STATE" --nomsg "$@"
1763 testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/${STATE}.output" "$CMP"
1764 fi
1765 fi
1766 msggroup
1767 }
1768 testsuccessequal() {
1769 # we compare output, so we know perfectly well about N:
1770 testreturnstateequal 'testsuccesswithglobalerror' 'testsuccess' 'WE' "$@"
1771 }
1772 testwarningequal() {
1773 testreturnstateequal 'testwarning' "$@"
1774 }
1775 testfailureequal() {
1776 testreturnstateequal 'testfailure' "$@"
1777 }
1778
1779 testfailuremsg() {
1780 msggroup 'testfailuremsg'
1781 local CMP="$1"
1782 shift
1783 testfailure "$@"
1784 msgtest 'Check that the output of the previous failed command has expected' 'failures and warnings'
1785 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailuremsg.comparefile"
1786 grep '^\(W\|E\|N\):' "${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output" > "$COMPAREFILE" 2>&1 || true
1787 testoutputequal "$COMPAREFILE" echo "$CMP"
1788 msggroup
1789 }
1790 testwarningmsg() {
1791 msggroup 'testwarningmsg'
1792 local CMP="$1"
1793 shift
1794 testwarning "$@"
1795 msgtest 'Check that the output of the previous warned command has expected' 'warnings'
1796 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testwarningmsg.comparefile"
1797 grep '^\(W\|E\|N\):' "${TMPWORKINGDIRECTORY}/rootdir/tmp/testwarning.output" > "$COMPAREFILE" 2>&1 || true
1798 testoutputequal "$COMPAREFILE" echo "$CMP"
1799 msggroup
1800 }
1801
1802 testfilestats() {
1803 msggroup 'testfilestats'
1804 msgtest "Test that file $1 has $2 $3" "$4"
1805 if [ "$4" "$3" "$(stat --format "$2" "$1")" ]; then
1806 msgpass
1807 else
1808 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfilestats.output"
1809 {
1810 ls -ld "$1" || true
1811 echo -n "stat(1) reports for $2: "
1812 stat --format "$2" "$1" || true
1813 } >"$OUTPUT" 2>&1
1814 msgfailoutput '' "$OUTPUT"
1815 fi
1816 msggroup
1817 }
1818 testaccessrights() {
1819 msggroup 'testaccessrights'
1820 testfilestats "$1" '%a' '=' "$2"
1821 msggroup
1822 }
1823
1824 testwebserverlaststatuscode() {
1825 msggroup 'testwebserverlaststatuscode'
1826 local DOWNLOG='rootdir/tmp/webserverstatus-testfile.log'
1827 local STATUS='downloaded/webserverstatus-statusfile.log'
1828 rm -f "$DOWNLOG" "$STATUS"
1829 msgtest 'Test last status code from the webserver was' "$1"
1830 if downloadfile "http://localhost:${APTHTTPPORT}/_config/find/aptwebserver::last-status-code" "$STATUS" > "$DOWNLOG" && [ "$(cat "$STATUS")" = "$1" ]; then
1831 msgpass
1832 else
1833 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testwebserverlaststatuscode.output"
1834 {
1835 if [ -n "$2" ]; then
1836 shift
1837 echo >&2 '#### Additionally provided output files contain:'
1838 cat >&2 "$@"
1839 fi
1840 echo >&2 '#### Download log of the status code:'
1841 cat >&2 "$DOWNLOG"
1842 } >"$OUTPUT" 2>&1
1843 msgfailoutput "Status was $(cat "$STATUS")" "$OUTPUT"
1844 fi
1845 msggroup
1846 }
1847
1848 createlistofkeys() {
1849 local OUTPUT="$1"
1850 shift
1851 while [ -n "$1" ]; do
1852 # gpg 2.1.something starts printing [SC] at some point
1853 if grep -q ' rsa2048/' "$OUTPUT" && grep -qF '[SC]' "$OUTPUT"; then
1854 case "$1" in
1855 *Joe*|*Sixpack*) echo 'pub rsa2048/DBAC8DAE 2010-08-18 [SC]';;
1856 *Rex*|*Expired*) echo 'pub rsa2048/27CE74F9 2013-07-12 [SC] [expired: 2013-07-13]';;
1857 *Marvin*|*Paranoid*) echo 'pub rsa2048/528144E2 2011-01-16 [SC]';;
1858 oldarchive) echo 'pub rsa1024/F68C85A3 2013-12-19 [SC]';;
1859 newarchive) echo 'pub rsa2048/DBAC8DAE 2010-08-18 [SC]';;
1860 *) echo 'UNKNOWN KEY';;
1861 esac
1862 # gpg 2.1 has a slightly different output format
1863 elif grep -q ' rsa2048/' "$OUTPUT"; then
1864 case "$1" in
1865 *Joe*|*Sixpack*) echo 'pub rsa2048/DBAC8DAE 2010-08-18';;
1866 *Rex*|*Expired*) echo 'pub rsa2048/27CE74F9 2013-07-12 [expired: 2013-07-13]';;
1867 *Marvin*|*Paranoid*) echo 'pub rsa2048/528144E2 2011-01-16';;
1868 oldarchive) echo 'pub rsa1024/F68C85A3 2013-12-19';;
1869 newarchive) echo 'pub rsa2048/DBAC8DAE 2010-08-18';;
1870 *) echo 'UNKNOWN KEY';;
1871 esac
1872 else
1873 case "$1" in
1874 *Joe*|*Sixpack*) echo 'pub 2048R/DBAC8DAE 2010-08-18';;
1875 *Rex*|*Expired*) echo 'pub 2048R/27CE74F9 2013-07-12 [expired: 2013-07-13]';;
1876 *Marvin*|*Paranoid*) echo 'pub 2048R/528144E2 2011-01-16';;
1877 oldarchive) echo 'pub 1024R/F68C85A3 2013-12-19';;
1878 newarchive) echo 'pub 2048R/DBAC8DAE 2010-08-18';;
1879 *) echo 'UNKNOWN KEY';;
1880 esac
1881 fi
1882 shift
1883 done
1884 }
1885 testaptkeys() {
1886 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/aptkeylist.output"
1887 if ! aptkey list | grep '^pub' > "$OUTPUT"; then
1888 echo -n > "$OUTPUT"
1889 fi
1890 testfileequal "$OUTPUT" "$(createlistofkeys "$OUTPUT" "$@")"
1891 }
1892
1893 pause() {
1894 echo "STOPPED execution. Press enter to continue"
1895 local IGNORE
1896 read IGNORE
1897 }
1898
1899 listcurrentlistsdirectory() {
1900 {
1901 find rootdir/var/lib/apt/lists -maxdepth 1 -type d | while read line; do
1902 stat --format '%U:%G:%a:%n' "$line"
1903 done
1904 find rootdir/var/lib/apt/lists -maxdepth 1 \! -type d | while read line; do
1905 stat --format '%U:%G:%a:%s:%y:%n' "$line"
1906 done
1907 } | sort
1908 }
1909 forallsupportedcompressors() {
1910 rm -f "${TMPWORKINGDIRECTORY}/rootdir/etc/apt/apt.conf.d/00force-compressor"
1911 for COMP in $(aptconfig dump 'APT::Compressor' --format '%f%n' | cut -d':' -f 5 | uniq); do
1912 if [ -z "$COMP" -o "$COMP" = '.' ]; then continue; fi
1913 "$@" "$COMP"
1914 done
1915 }
1916
1917 ### convenience hacks ###
1918 mkdir() {
1919 # creating some directories by hand is a tedious task, so make it look simple
1920 local PARAMS="$*"
1921 if [ "$PARAMS" != "${PARAMS#*rootdir/var/lib/apt/lists}" ]; then
1922 # only the last directory created by mkdir is effected by the -m !
1923 command mkdir -m 755 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt"
1924 command mkdir -m 755 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists"
1925 command mkdir -m 700 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial"
1926 touch "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/lock"
1927 if [ "$(id -u)" = '0' ]; then
1928 chown _apt:root "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial"
1929 fi
1930 else
1931 command mkdir "$@"
1932 fi
1933 }
1934
1935 ### The following tests are run by most test methods automatically to check
1936 ### general things about commands executed without writing the test every time.
1937
1938 aptautotest() {
1939 local TESTCALL="$1"
1940 local CMD="$2"
1941 local FIRSTOPT="$3"
1942 local AUTOTEST="aptautotest_$(echo "${CMD##*/}_${FIRSTOPT}" | tr -d -c 'A-za-z0-9')"
1943 if command -v $AUTOTEST >/dev/null; then
1944 shift 3
1945 # save and restore the *.output files from other tests
1946 # as we might otherwise override them in these automatic tests
1947 rm -rf "${TMPWORKINGDIRECTORY}/rootdir/tmp-before"
1948 mv "${TMPWORKINGDIRECTORY}/rootdir/tmp" "${TMPWORKINGDIRECTORY}/rootdir/tmp-before"
1949 mkdir "${TMPWORKINGDIRECTORY}/rootdir/tmp"
1950 $AUTOTEST "$TESTCALL" "$@"
1951 rm -rf "${TMPWORKINGDIRECTORY}/rootdir/tmp-aptautotest"
1952 mv "${TMPWORKINGDIRECTORY}/rootdir/tmp" "${TMPWORKINGDIRECTORY}/rootdir/tmp-aptautotest"
1953 mv "${TMPWORKINGDIRECTORY}/rootdir/tmp-before" "${TMPWORKINGDIRECTORY}/rootdir/tmp"
1954 fi
1955 }
1956
1957 aptautotest_aptget_update() {
1958 local TESTCALL="$1"
1959 while [ -n "$2" ]; do
1960 if [ "$2" = '--print-uris' ]; then return; fi # simulation mode
1961 shift
1962 done
1963 if ! test -d "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists"; then return; fi
1964 testfilestats "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:755"
1965 testfilestats "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:755"
1966 # all copied files are properly chmodded
1967 local backupIFS="$IFS"
1968 IFS="$(printf "\n\b")"
1969 for file in $(find "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" -type f ! -name 'lock'); do
1970 testfilestats "$file" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:644"
1971 done
1972 IFS="$backupIFS"
1973 if [ "$TESTCALL" = 'testsuccess' ]; then
1974 # failure cases can retain partial files and such
1975 testempty find "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial" -mindepth 1 ! \( -name 'lock' -o -name '*.FAILED' \)
1976 fi
1977 }
1978 aptautotest_apt_update() { aptautotest_aptget_update "$@"; }
1979 aptautotest_aptcdrom_add() { aptautotest_aptget_update "$@"; }
1980
1981 testaptautotestnodpkgwarning() {
1982 local TESTCALL="$1"
1983 while [ -n "$2" ]; do
1984 if expr match "$2" '^-[a-z]*s' >/dev/null 2>&1; then return; fi # simulation mode
1985 if expr match "$2" '^-dy\?' >/dev/null 2>&1; then return; fi # download-only mode
1986 shift
1987 done
1988 testfailure grep '^dpkg: warning:.*ignor.*' "${TMPWORKINGDIRECTORY}/rootdir/tmp-before/${TESTCALL}.output"
1989 }
1990
1991 aptautotest_aptget_install() { testaptautotestnodpkgwarning "$@"; }
1992 aptautotest_aptget_remove() { testaptautotestnodpkgwarning "$@"; }
1993 aptautotest_aptget_purge() { testaptautotestnodpkgwarning "$@"; }
1994 aptautotest_apt_install() { testaptautotestnodpkgwarning "$@"; }
1995 aptautotest_apt_remove() { testaptautotestnodpkgwarning "$@"; }
1996 aptautotest_apt_purge() { testaptautotestnodpkgwarning "$@"; }